
// What variables to show
#define No_variables		0
#define Global_variables	1
#define Static_variables	2
#define Static_function_variables	3


class Cvariable : public Cclassmember {
private:
	Cvariable(const char *nameP);

public:
	static Cvariable 	*g_hash[HASHSIZE];
	static unsigned int	g_hash_cnt;
	static Cvariable	*g_local_headP;

	Cvariable		*m_hashP;
	Cvariable		*m_local_nextP;

	static void		reset(void);
	static Cvariable *locate(const char *nameP, int flags, Centity *sourceP, Centity *functionP);
	static void     resolve(int show_variables, int no_function_calls);

	const char		*get_type(void) const;

	virtual objectE	type(void) const;
	virtual void	emit_id(void) const;
	virtual void	print(void) const;

	virtual void	emit_instance(void) const;
	virtual	void	emit_edges(void);
	void			emit_attributes(void) const;
};

